#!/usr/bin/env python

# import argparse
import sys

import cv2 as cv
import dlib
import numpy as np

# ----------------------------------------------------------------------------

def boundingRect(rect):
    x = rect.left()
    y = rect.top()
    w = rect.right() - x
    h = rect.bottom() - y
    return x, y, w, h

# ----------------------------------------------------------------------------

def getCoords(shape):
    coords = np.zeros((68,2), dtype='int')
    for i in range(68):
        coords[i] = (shape.part(i).x, shape.part(i).y)
    return coords

# ----------------------------------------------------------------------------

SP_DATA = 'shape_predictor_68_face_landmarks.dat'

# ----------------------------------------------------------------------------

# ap = argparse.ArgumentParser()
# ap.add_argument("-i", "--image", required=True,
#                 help="path to input image")
# args = vars(ap.parse_args())
# img = cv.imread(args["image"])

if len(sys.argv) == 1:
    print 'Usage: facial.py <file>'
    sys.exit(1)
else:
    filename = sys.argv[1]

detector = dlib.get_frontal_face_detector()
predictor = dlib.shape_predictor(SP_DATA)

img = cv.imread(filename)
# img = cv.resize(img, (500,500))
gray = cv.cvtColor(img, cv.COLOR_BGR2GRAY)

rects = detector(gray, 1)

for i, rect in enumerate(rects):
    x, y, w, h = boundingRect(rect)
    cv.rectangle(img, (x,y), (x+w,y+h), (255,0,0), 1)

    shape = predictor(gray, rect)
    coords = getCoords(shape)
    for x, y in coords[36:42]:
        cv.circle(img, (x,y), 1, (0,0,255), cv.FILLED)
    for x, y in coords[42:48]:
        cv.circle(img, (x,y), 1, (0,255,0), cv.FILLED)

cv.imshow('image', img)
cv.waitKey(0)
